<script lang="ts">
import NextStep from '~/components/common/next-step.vue';
import {
  AosAnimationsMixin,
  FooterEditLinkMixin,
  LivePreviewMixin,
} from '~/mixins';
import { CtfCustomPage, CtfEntry } from '~/models';
import { ContentfulLivePreview } from '@contentful/live-preview';
import * as ContentfulComponents from '../components/contentful';
import SlpNavigationHOC from '~/components/navigation/navigation-hoc.vue';
import NavBanner from '~/components/navigation/nav-banner.vue';
import SlpFooterHOC from '~/components/navigation/footer-hoc.vue';
import { generateLayoutMeta, getPageMetadata } from '~/common/meta';
import { MetaInfo } from 'vue-meta/types/vue-meta';

export default {
  components: {
    SlpFooterHOC,
    NavBanner,
    SlpNavigationHOC,
    NextStep,
    ...ContentfulComponents,
  },
  mixins: [LivePreviewMixin, AosAnimationsMixin, FooterEditLinkMixin],
  data() {
    return {
      contentfulData: null,
      sideNavigation: null,
      metadata: null,
      spaceId: null,
      entryId: null,
      contentfulEntryUrl: '',
    };
  },
  nuxtI18n: false,
  async fetch() {
    const slug = Object.values(this.$route.params).join('/');
    let contentfulData: CtfEntry<CtfCustomPage>;

    try {
      contentfulData = await this.$contentfulService.getCustomPage(`/${slug}/`);
    } catch (e) {
      throw new Error(e);
    }

    this.contentfulData = contentfulData;
    this.metadata = contentfulData?.fields?.seoMetaData?.fields || {};
    this.spaceId = contentfulData.sys.space.sys.id;
    this.entryId = contentfulData.sys.id;

    if (
      this.contentfulData.fields?.components &&
      !this.contentfulData.fields?.components.length
    ) {
      throw new Error('Empty page found');
    }

    if (
      this.contentfulData.fields?.components &&
      this.contentfulData.fields.activateSideMenu
    ) {
      this.sideNavigation = this.$contentfulService.mapSideNavigation(
        this.contentfulData.fields.components,
      );
    }
  },
  head(): MetaInfo {
    const metadata = getPageMetadata(this.metadata || {}, this.$route.path);
    const layoutMeta = generateLayoutMeta(this.$route.path, this.$i18n.locale);

    return {
      ...metadata,
      link: [...metadata.link, ...layoutMeta.link],
      htmlAttrs: { ...layoutMeta.htmlAttrs },
    } as MetaInfo;
  },
  created() {
    this.$nuxt.$on('contentfulIds', (data) => {
      const { spaceId, entryId } = data;
      if (spaceId !== undefined && entryId !== undefined) {
        this.contentfulEntryUrl = `https://app.contentful.com/spaces/${spaceId}/entries/${entryId}`;
      }
    });
  },
  mounted() {
    this.$nuxt.$emit('contentfulIds', {
      spaceId: this.spaceId,
      entryId: this.entryId,
    });
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.contentfulData,
        callback: (updatedData) => {
          this.contentfulData = updatedData;
          if (this.contentfulData.fields.components) {
            this.sideNavigation = this.$contentfulService.mapSideNavigation(
              this.contentfulData.fields.components,
            );
          }
        },
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
};
</script>

<!--
     Dynamic layout used for pages created in Contentful
     Do not add specific logic/components in this template unless it has been decided and approved by the team.
     This template is meant to be dynamic and the content should be rendered only by using dynamic components
-->
<template>
  <div>
    <!-- <HomeTopBanner /> -->
    <NavBanner :current-locale="$i18n.locale" />
    <SlpNavigationHOC />
    <!--Contentful Content Start-->
    <SlpContainer v-if="contentfulData">
      <Hero :data="contentfulData.fields" />
      <template v-if="contentfulData.fields.activateSideMenu && sideNavigation">
        <SlpSideNavigation :data="sideNavigation">
          <section
            v-for="(component, i) in contentfulData.fields.components"
            :key="i"
          >
            <component
              :is="component.fields.componentName"
              :data="component.fields"
            />
          </section>
        </SlpSideNavigation>
      </template>
      <template v-else>
        <section
          v-for="(component, i) in contentfulData.fields.components"
          :key="i"
        >
          <component
            :is="component.fields.componentName"
            :data="component.fields"
          />
        </section>
      </template>
      <NextStep v-show="contentfulData.fields.hasNextStepComponent" />
    </SlpContainer>
    <!--Contentful Content End-->
    <SlpFooterHOC :contentful-entry-id="contentfulEntryUrl" />
  </div>
</template>
